-#!/usr/pkg/bin/perl
+#!/usr/bin/perl
package IkiWiki::Plugin::cvs;
-# Copyright (c) 2008 Amitai Schlair
+# Copyright (c) 2009 Amitai Schlair
# All rights reserved.
#
# This code is derived from software contributed to ikiwiki
hook(type => "rcs", id => "rcs_recentchanges", call => \&rcs_recentchanges);
hook(type => "rcs", id => "rcs_diff", call => \&rcs_diff);
hook(type => "rcs", id => "rcs_getctime", call => \&rcs_getctime);
+ hook(type => "rcs", id => "rcs_getmtime", call => \&rcs_getmtime);
}
sub genwrapper () {
- my $check_args=<<"EOF";
+ return <<EOF;
{
int j;
for (j = 1; j < argc; j++)
exit(0);
}
EOF
- return $check_args;
}
sub checkconfig () {
plugin => {
safe => 0, # rcs plugin
rebuild => undef,
+ section => "rcs",
},
cvsrepo => {
type => "string",
cvs_wrapper => {
type => "string",
example => "/cvs/wikirepo/CVSROOT/post-commit",
- description => "cvs post-commit hook to generate (triggered by CVSROOT/loginfo entry",
+ description => "cvs post-commit hook to generate (triggered by CVSROOT/loginfo entry)",
safe => 0, # file
rebuild => 0,
},
if (defined($filemime) && $filemime eq 'text/plain') {
cvs_runcvs('add', $file) ||
warn("cvs add $file failed\n");
- } else {
+ }
+ else {
cvs_runcvs('add', '-kb', $file) ||
warn("cvs add binary $file failed\n");
}
- } else {
+ }
+ else {
# directory
cvs_runcvs('add', $file) ||
warn("cvs add $file failed\n");
eval q{use File::ReadBackwards};
error($@) if $@;
- my (undef, $tmpfile) = tempfile(OPEN=>0);
+ my ($tmphandle, $tmpfile) = tempfile();
system("env TZ=UTC cvsps -q --cvs-direct -z 30 -x >$tmpfile");
if ($? == -1) {
error "couldn't run cvsps: $!\n";
- } elsif (($? >> 8) != 0) {
+ }
+ elsif (($? >> 8) != 0) {
error "cvsps exited " . ($? >> 8) . ": $!\n";
}
$message[0]->{line}=~/$config{web_commit_regexp}/) {
$user=defined $2 ? "$2" : "$3";
$message[0]->{line}=$4;
- } else {
+ }
+ else {
$committype="cvs";
}
$line = <SPSVC>;
if ($line =~ /^Author: (.*)$/) {
$user = $1 unless defined $user && length $user;
- } else {
+ }
+ else {
error "expected Author, got $line";
}
$line = <SPSVC>;
if ($line =~ /^Date: (.*)$/) {
$when = str2time($1, 'UTC');
- } else {
+ }
+ else {
error "expected Date, got $line";
}
$line = <SPSVC>;
if ($line =~ /^PatchSet (.*)$/) {
$rev = $1;
- } else {
+ }
+ else {
error "expected PatchSet, got $line";
}
if (wantarray) {
return @cvsps;
- } else {
+ }
+ else {
return join("", @cvsps);
}
}
return $date;
}
+sub rcs_getmtime ($) {
+ error "rcs_getmtime is not implemented for cvs\n"; # TODO
+}
+
1